diff --git a/servo/components/style/Cargo.toml b/servo/components/style/Cargo.toml
index 88b64ca81445..6de2b912db16 100644
--- a/servo/components/style/Cargo.toml
+++ b/servo/components/style/Cargo.toml
@@ -73,12 +73,12 @@ unicode-segmentation = "1.0"
 void = "1.0.2"
 
 [target.'cfg(windows)'.dependencies]
 kernel32-sys = "0.2"
 
 [build-dependencies]
 lazy_static = "1"
 log = "0.3"
-bindgen = { version = "0.33.1", optional = true, default-features = false }
+bindgen = { version = "0.37", optional = true, default-features = false }
 regex = {version = "0.2", optional = true}
 walkdir = "1.0"
 toml = {version = "0.2.1", optional = true, default-features = false}
diff --git a/third_party/rust/aho-corasick/benches/bench.rs b/third_party/rust/aho-corasick/benches/bench.rs
index d51bcaeec975..0e68e2af02d8 100644
--- a/third_party/rust/aho-corasick/benches/bench.rs
+++ b/third_party/rust/aho-corasick/benches/bench.rs
@@ -52,16 +52,50 @@ fn bench_full_aut_overlapping_no_match<P: AsRef<[u8]>, T: Transitions>(
 
 fn bench_naive_no_match<S>(b: &mut Bencher, needles: Vec<S>, haystack: &str)
         where S: Into<String> {
     b.bytes = haystack.len() as u64;
     let needles: Vec<String> = needles.into_iter().map(Into::into).collect();
     b.iter(|| assert!(!naive_find(&needles, haystack)));
 }
 
+#[bench]
+fn bench_construction(b: &mut Bencher) {
+    b.iter(|| {
+        AcAutomaton::new(test::black_box(
+            [
+                "ADL", "ADl", "AdL", "Adl", "BAK", "BAk", "BAK", "BaK", "Bak", "BaK", "HOL",
+                "HOl", "HoL", "Hol", "IRE", "IRe", "IrE", "Ire", "JOH", "JOh", "JoH", "Joh", "SHE",
+                "SHe", "ShE", "She", "WAT", "WAt", "WaT", "Wat", "aDL", "aDl", "adL", "adl", "bAK",
+                "bAk", "bAK", "baK", "bak", "baK", "hOL", "hOl", "hoL", "hol", "iRE", "iRe",
+                "irE", "ire", "jOH", "jOh", "joH", "joh", "sHE", "sHe", "shE", "she", "wAT", "wAt",
+                "waT", "wat", "ſHE", "ſHe", "ſhE", "ſhe",
+            ].iter()
+                .map(|x| *x),
+        ))
+    })
+}
+
+#[bench]
+fn bench_full_construction(b: &mut Bencher) {
+    b.iter(|| {
+        AcAutomaton::new(test::black_box(
+            [
+                "ADL", "ADl", "AdL", "Adl", "BAK", "BAk", "BAK", "BaK", "Bak", "BaK", "HOL",
+                "HOl", "HoL", "Hol", "IRE", "IRe", "IrE", "Ire", "JOH", "JOh", "JoH", "Joh", "SHE",
+                "SHe", "ShE", "She", "WAT", "WAt", "WaT", "Wat", "aDL", "aDl", "adL", "adl", "bAK",
+                "bAk", "bAK", "baK", "bak", "baK", "hOL", "hOl", "hoL", "hol", "iRE", "iRe",
+                "irE", "ire", "jOH", "jOh", "joH", "joh", "sHE", "sHe", "shE", "she", "wAT", "wAt",
+                "waT", "wat", "ſHE", "ſHe", "ſhE", "ſhe",
+            ].iter()
+                .map(|x| *x),
+        )).into_full()
+    })
+}
+
 fn haystack_same(letter: char) -> String {
     iter::repeat(letter).take(10000).collect()
 }
 
 macro_rules! aut_benches {
     ($prefix:ident, $aut:expr, $bench:expr) => {
         mod $prefix {
 #![allow(unused_imports)]
diff --git a/third_party/rust/aho-corasick/ci/script.sh b/third_party/rust/aho-corasick/ci/script.sh
new file mode 100755
index 000000000000..effebc4d8f88
--- /dev/null
+++ b/third_party/rust/aho-corasick/ci/script.sh
@@ -0,0 +1,20 @@
+#!/bin/sh
+
+set -ex
+
+cargo build --verbose
+cargo doc --verbose
+
+# If we're testing on an older version of Rust, then only check that we
+# can build the crate. This is because the dev dependencies might be updated
+# more frequently, and therefore might require a newer version of Rust.
+#
+# This isn't ideal. It's a compromise.
+if [ "$TRAVIS_RUST_VERSION" = "1.13.0" ]; then
+  exit
+fi
+
+cargo test --verbose
+if [ "$TRAVIS_RUST_VERSION" = "nightly" ]; then
+  cargo bench --verbose --no-run
+fi
diff --git a/third_party/rust/aho-corasick/examples/dict-search.rs b/third_party/rust/aho-corasick/examples/dict-search.rs
index e4cb28854b22..b620cc284a7d 100644
--- a/third_party/rust/aho-corasick/examples/dict-search.rs
+++ b/third_party/rust/aho-corasick/examples/dict-search.rs
@@ -1,25 +1,27 @@
 // This example demonstrates how to use the Aho-Corasick algorithm to rapidly
 // scan text for matches in a large dictionary of keywords. This example by
 // default reads your system's dictionary (~120,000 words).
 extern crate aho_corasick;
 extern crate csv;
 extern crate docopt;
 extern crate memmap;
-extern crate rustc_serialize;
+extern crate serde;
+#[macro_use]
+extern crate serde_derive;
 
 use std::error::Error;
 use std::fs::File;
 use std::io::{self, BufRead, Write};
 use std::process;
 
 use aho_corasick::{Automaton, AcAutomaton, Match};
 use docopt::Docopt;
-use memmap::{Mmap, Protection};
+use memmap::Mmap;
 
 static USAGE: &'static str = "
 Usage: dict-search [options] <input>
        dict-search --help
 
 Options:
     -d <path>, --dict <path>   Path to dictionary of keywords to search.
                                [default: /usr/share/dict/words]
@@ -28,30 +30,30 @@ Options:
     --overlapping              Report overlapping matches.
     -c, --count                Show only the numebr of matches.
     --memory-usage             Show memory usage of automaton.
     --full                     Use fully expanded transition matrix.
                                Warning: may use lots of memory.
     -h, --help                 Show this usage message.
 ";
 
-#[derive(Clone, Debug, RustcDecodable)]
+#[derive(Clone, Debug, Deserialize)]
 struct Args {
     arg_input: String,
     flag_dict: String,
     flag_min_len: usize,
     flag_overlapping: bool,
     flag_memory_usage: bool,
     flag_full: bool,
     flag_count: bool,
 }
 
 fn main() {
     let args: Args = Docopt::new(USAGE)
-                            .and_then(|d| d.decode())
+                            .and_then(|d| d.deserialize())
                             .unwrap_or_else(|e| e.exit());
     match run(&args) {
         Ok(()) => {}
         Err(err) => {
             writeln!(&mut io::stderr(), "{}", err).unwrap();
             process::exit(1);
         }
     }
@@ -65,76 +67,61 @@ fn run(args: &Args) -> Result<(), Box<Error>> {
             (aut.heap_bytes(), aut.num_states())
         } else {
             (aut.heap_bytes(), aut.num_states())
         };
         println!("{} bytes, {} states", bytes, states);
         return Ok(());
     }
 
+    let rdr = try!(File::open(&args.arg_input));
     if args.flag_full {
         let aut = aut.into_full();
         if args.flag_overlapping {
             if args.flag_count {
-                let mmap = Mmap::open_path(
-                    &args.arg_input, Protection::Read).unwrap();
-                let text = unsafe { mmap.as_slice() };
-                println!("{}", aut.find_overlapping(text).count());
+                let mmap = unsafe { try!(Mmap::map(&rdr)) };
+                println!("{}", aut.find_overlapping(&*mmap).count());
             } else {
-                let rdr = try!(File::open(&args.arg_input));
                 try!(write_matches(&aut, aut.stream_find_overlapping(rdr)));
             }
         } else {
             if args.flag_count {
-                let mmap = Mmap::open_path(
-                    &args.arg_input, Protection::Read).unwrap();
-                let text = unsafe { mmap.as_slice() };
-                println!("{}", aut.find(text).count());
+                let mmap = unsafe { try!(Mmap::map(&rdr)) };
+                println!("{}", aut.find(&*mmap).count());
             } else {
-                let rdr = try!(File::open(&args.arg_input));
                 try!(write_matches(&aut, aut.stream_find(rdr)));
             }
         }
     } else {
         if args.flag_overlapping {
             if args.flag_count {
-                let mmap = Mmap::open_path(
-                    &args.arg_input, Protection::Read).unwrap();
-                let text = unsafe { mmap.as_slice() };
-                println!("{}", aut.find_overlapping(text).count());
+                let mmap = unsafe { try!(Mmap::map(&rdr)) };
+                println!("{}", aut.find_overlapping(&*mmap).count());
             } else {
-                let rdr = try!(File::open(&args.arg_input));
                 try!(write_matches(&aut, aut.stream_find_overlapping(rdr)));
             }
         } else {
             if args.flag_count {
-                let mmap = Mmap::open_path(
-                    &args.arg_input, Protection::Read).unwrap();
-                let text = unsafe { mmap.as_slice() };
-                println!("{}", aut.find(text).count());
+                let mmap = unsafe { try!(Mmap::map(&rdr)) };
+                println!("{}", aut.find(&*mmap).count());
             } else {
-                let rdr = try!(File::open(&args.arg_input));
                 try!(write_matches(&aut, aut.stream_find(rdr)));
             }
         }
     }
     Ok(())
 }
 
 fn write_matches<A, I>(aut: &A, it: I) -> Result<(), Box<Error>>
         where A: Automaton<String>, I: Iterator<Item=io::Result<Match>> {
     let mut wtr = csv::Writer::from_writer(io::stdout());
-    try!(wtr.write(["pattern", "start", "end"].iter()));
+    try!(wtr.serialize(("pattern", "start", "end")));
     for m in it {
         let m = try!(m);
-        try!(wtr.write([
-            aut.pattern(m.pati),
-            &m.start.to_string(),
-            &m.end.to_string(),
-        ].iter()));
+        try!(wtr.serialize((aut.pattern(m.pati), m.start, m.end)));
     }
     try!(wtr.flush());
     Ok(())
 }
 
 fn build_automaton(
     dict_path: &str,
     min_len: usize,
diff --git a/third_party/rust/aho-corasick/src/autiter.rs b/third_party/rust/aho-corasick/src/autiter.rs
index 21a02a4cf10b..dfad28f67aa2 100644
--- a/third_party/rust/aho-corasick/src/autiter.rs
+++ b/third_party/rust/aho-corasick/src/autiter.rs
@@ -37,17 +37,17 @@ pub trait Automaton<P> {
     #[inline]
     fn len(&self) -> usize {
         self.patterns().len()
     }
 
     /// Returns true if the automaton has no patterns.
     #[inline]
     fn is_empty(&self) -> bool {
-        self.len() == 0
+        self.patterns().is_empty()
     }
 
     /// Returns an iterator of non-overlapping matches in `s`.
     fn find<'a, 's, Q: ?Sized + AsRef<[u8]>>(
         &'a self,
         s: &'s Q,
     ) -> Matches<'a, 's, P, Self>
     where Self: Sized {
@@ -376,17 +376,17 @@ impl<'a, R: io::Read, P, A: Automaton<P>>
 
     fn next(&mut self) -> Option<io::Result<Match>> {
         let mut m = None;
         let mut consumed = 0;
 'LOOP:  loop {
             self.buf.consume(consumed);
             let bs = match self.buf.fill_buf() {
                 Err(err) => return Some(Err(err)),
-                Ok(bs) if bs.len() == 0 => break,
+                Ok(bs) if bs.is_empty() => break,
                 Ok(bs) => bs,
             };
             consumed = bs.len(); // is shortened if we find a match
             for (i, &b) in bs.iter().enumerate() {
                 self.si = self.aut.next_state(self.si, b);
                 if self.aut.has_match(self.si, 0) {
                     m = Some(Ok(self.aut.get_match(self.si, 0, self.texti)));
                     consumed = i + 1;
@@ -500,17 +500,17 @@ impl<'a, R: io::Read, P, A: Automaton<P> + ?Sized>
         }
         let mut m = None;
         let mut consumed = 0;
         self.outi = 0;
 'LOOP:  loop {
             self.buf.consume(consumed);
             let bs = match self.buf.fill_buf() {
                 Err(err) => return Some(Err(err)),
-                Ok(bs) if bs.len() == 0 => break,
+                Ok(bs) if bs.is_empty() => break,
                 Ok(bs) => bs,
             };
             consumed = bs.len(); // is shortened if we find a match
             for (i, &b) in bs.iter().enumerate() {
                 self.si = self.aut.next_state(self.si, b);
                 if self.aut.has_match(self.si, self.outi) {
                     m = Some(Ok(self.aut.get_match(
                         self.si, self.outi, self.texti)));
diff --git a/third_party/rust/aho-corasick/src/full.rs b/third_party/rust/aho-corasick/src/full.rs
index f7d7c637e829..377940afabd8 100644
--- a/third_party/rust/aho-corasick/src/full.rs
+++ b/third_party/rust/aho-corasick/src/full.rs
@@ -39,33 +39,33 @@ impl<P: AsRef<[u8]>> FullAcAutomaton<P> {
         fac.start_bytes = ac.start_bytes;
         fac
     }
 
     #[doc(hidden)]
     pub fn memory_usage(&self) -> usize {
         self.pats.iter()
             .map(|p| vec_bytes() + p.as_ref().len())
-            .fold(0, |a, b| a + b)
+            .sum::<usize>()
         + (4 * self.trans.len())
         + self.out.iter()
               .map(|v| vec_bytes() + (usize_bytes() * v.len()))
-              .fold(0, |a, b| a + b)
+              .sum::<usize>()
         + self.start_bytes.len()
     }
 
     #[doc(hidden)]
     pub fn heap_bytes(&self) -> usize {
         self.pats.iter()
             .map(|p| mem::size_of::<P>() + p.as_ref().len())
-            .fold(0, |a, b| a + b)
+            .sum::<usize>()
         + (4 * self.trans.len())
         + self.out.iter()
               .map(|v| vec_bytes() + (usize_bytes() * v.len()))
-              .fold(0, |a, b| a + b)
+              .sum::<usize>()
         + self.start_bytes.len()
     }
 
     fn set(&mut self, si: StateIdx, i: u8, goto: StateIdx) {
         let ns = self.num_states();
         self.trans[i as usize * ns + si as usize] = goto;
     }
 
@@ -114,23 +114,32 @@ impl<P: AsRef<[u8]>> Automaton<P> for FullAcAutomaton<P> {
     fn pattern(&self, i: usize) -> &P {
         &self.pats[i]
     }
 }
 
 impl<P: AsRef<[u8]>> FullAcAutomaton<P> {
     fn build_matrix<T: Transitions>(&mut self, ac: &AcAutomaton<P, T>) {
         for (si, s) in ac.states.iter().enumerate().skip(1) {
-            for b in (0..256).map(|b| b as u8) {
-                self.set(si as StateIdx, b, ac.next_state(si as StateIdx, b));
-            }
-            for &pati in &s.out {
-                self.out[si].push(pati);
-            }
+            self.set_states(ac, si as StateIdx);
+            self.out[si].extend_from_slice(&s.out);
         }
     }
+
+    fn set_states<T: Transitions>(&mut self, ac: &AcAutomaton<P, T>, si: StateIdx) {
+        let current_state = &ac.states[si as usize];
+        let first_fail_state = current_state.fail;
+        current_state.for_each_transition(move |b, maybe_si| {
+            let goto = if maybe_si == FAIL_STATE {
+                ac.memoized_next_state(self, si, first_fail_state, b)
+            } else {
+                maybe_si
+            };
+            self.set(si, b, goto);
+        });
+    }
 }
 
 impl<P: AsRef<[u8]> + fmt::Debug> fmt::Debug for FullAcAutomaton<P> {
     fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
         write!(f, "FullAcAutomaton({:?})", self.pats)
     }
 }
